#!/usr/bin/env python
import coral


o = coral.Sequence()

d0 = coral.PresentationElement()
d1 = coral.PresentationElement()
d2 = coral.PresentationElement()
d3 = coral.PresentationElement()
d4 = coral.PresentationElement()
d5 = coral.PresentationElement()
d6 = coral.PresentationElement()
d7 = coral.PresentationElement()

o.add(d0)
o.add(d1)
o.add(d2)
o.add(d3)
o.add(d4)
o.add(d5)
o.add(d6)
o.add(d7)

assert(o[0] == d0)
assert(o[1] == d1)
assert(o[2] == d2)
assert(o[3] == d3)
assert(o[4] == d4)
assert(o[5] == d5)
assert(o[6] == d6)
assert(o[7] == d7)

o.drop(d4)

assert(o[0] == d0)
assert(o[1] == d1)
assert(o[2] == d2)
assert(o[3] == d3)
###assert(o[4] == d4)
assert(o[4] == d5)
assert(o[5] == d6)
assert(o[6] == d7)

o.insert(d4, 3)

assert(o[0] == d0)
assert(o[1] == d1)
assert(o[2] == d2)
assert(o[3] == d4)
assert(o[4] == d3)
assert(o[5] == d5)
assert(o[6] == d6)
assert(o[7] == d7)

o.reset()
o.add(d1)
o.add(d1)
o.add(d1)

assert(o[0] == d1)
assert(o[1] == d1)
assert(o[2] == d1)

o.insert(d2, 2);
assert(o[0] == d1)
assert(o[1] == d1)
assert(o[2] == d2)
assert(o[3] == d1)
